<template>
  <v-container class="fill-height">
    <v-row
      align="center"
      justify="center"
    >
      <v-dialog
        v-model="registerDialog"
        class="pa-4"
        scrollable
        max-width="600"
      >
        <register-dialog @registered="registered($event)" />
      </v-dialog>
      <v-col
        cols="12"
        sm="12"
        md="10"
        lg="7"
      >
        <img
          src="https://grady.informatik.uni-goettingen.de/static/img/brand.svg"
          class="grady-logo"
        >
      </v-col>
      <v-divider
        vertical
        inset
        class="ma-4"
      />
      <v-col
        class="text-center"
        cols="8"
        sm="6"
        md="4"
        lg="2"
      >
        <h2 class="pt-3">
          Log in
        </h2>
        <v-alert
          :value="msg.length !== 0"
          outlined
          color="error"
          transition="fade-transition"
        >
          {{ msg }}
        </v-alert>
        <p v-if="msg.length === 0">
          But I corrected them, sir.
        </p>
        <v-form
          @submit.prevent="submit"
        >
          <v-text-field
            id="username"
            v-model="credentials.username"
            label="Username"
            required
            autofocus
          />
          <v-text-field
            id="password"
            v-model="credentials.password"
            label="Password"
            type="password"
            required
          />
          <v-row class="btn-container">
            <v-btn
              id="register"
              @click="registerDialog = true"
            >
              Register
            </v-btn>
            <v-btn
              :loading="loading"
              type="submit"
              color="primary"
            >
              Access
            </v-btn>
          </v-row>
        </v-form>
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
import { mapActions, mapState } from 'vuex'
import RegisterDialog from '@/components/RegisterDialog'
import { Authentication as Auth } from '@/store/modules/authentication'
import { ConfigModule } from '../store/modules/config'

export default {
  name: 'GradyLogin',
  components: { RegisterDialog },
  data () {
    return {
      credentials: {
        username: '',
        password: ''
      },
      registerDialog: false,
      loading: false
    }
  },
  computed: {
    msg () { return Auth.state.message },
    userRole () { return Auth.state.user.role },
  },
  methods: {
    submit () {
      this.loading = true
      Auth.getJWT(this.credentials).then(() => {
        return Promise.all([
          Auth.getUser(),
          ConfigModule.getConfig()
        ])
      }).then(() => {
        this.$router.push({ name: 'exam-selection' })
        this.loading = false
      }).catch((err) => {
        let msg = 'Login failed. Please try again.'
        if (typeof err === 'string') {
          msg = err
        }

        Auth.SET_MESSAGE(msg)
        this.loading = false
      })
    },
    registered (credentials) {
      this.registerDialog = false
      this.credentials.username = credentials.username
      this.credentials.password = credentials.password
      Auth.SET_MESSAGE('Your account is being activated. Please wait.')
    }
  }
}
</script>

<style scoped>
  .v-btn {
    margin: 0px;
  }

  .btn-container {
    display: flex;
    flex-wrap: nowrap;
    justify-content: space-around;
  }

  .grady-logo {
    width: 100%;
  }
</style>
